/*******************************************************************************
 * Copyright (c) 2011 Vrije Universiteit Brussel.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Dennis Wagelaar, Vrije Universiteit Brussel - initial API and
 *         implementation and/or initial documentation
 *******************************************************************************/
package org.eclipse.m2m.atl.emftvm.tests;

import org.eclipse.m2m.atl.emftvm.LocalVariableInstruction;

/**
 * <!-- begin-user-doc -->
 * A test case for the model object '<em><b>Local Variable Instruction</b></em>'.
 * @author <a href="mailto:dennis.wagelaar@vub.ac.be">Dennis Wagelaar</a>
 * <!-- end-user-doc -->
 * <p>
 * The following features are tested:
 * <ul>
 *   <li>{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getCbOffset() <em>Cb Offset</em>}</li>
 *   <li>{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getSlot() <em>Slot</em>}</li>
 *   <li>{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getLocalVariableIndex() <em>Local Variable Index</em>}</li>
 *   <li>{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getLocalVariable() <em>Local Variable</em>}</li>
 * </ul>
 * </p>
 * @generated
 */
public abstract class LocalVariableInstructionTest extends InstructionTest {

	/**
	 * Constructs a new Local Variable Instruction test case with the given name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LocalVariableInstructionTest(String name) {
		super(name);
	}

	/**
	 * Returns the fixture for this Local Variable Instruction test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected LocalVariableInstruction getFixture() {
		return (LocalVariableInstruction)fixture;
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getCbOffset() <em>Cb Offset</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getCbOffset()
	 * @generated
	 */
	public void testGetCbOffset() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#setCbOffset(int) <em>Cb Offset</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#setCbOffset(int)
	 * @generated
	 */
	public void testSetCbOffset() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getSlot() <em>Slot</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getSlot()
	 * @generated
	 */
	public void testGetSlot() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getLocalVariableIndex() <em>Local Variable Index</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getLocalVariableIndex()
	 * @generated
	 */
	public void testGetLocalVariableIndex() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#setLocalVariableIndex(int) <em>Local Variable Index</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#setLocalVariableIndex(int)
	 * @generated
	 */
	public void testSetLocalVariableIndex() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getLocalVariable() <em>Local Variable</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#getLocalVariable()
	 * @generated
	 */
	public void testGetLocalVariable() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#setLocalVariable(org.eclipse.m2m.atl.emftvm.LocalVariable) <em>Local Variable</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.m2m.atl.emftvm.LocalVariableInstruction#setLocalVariable(org.eclipse.m2m.atl.emftvm.LocalVariable)
	 * @generated
	 */
	public void testSetLocalVariable() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

} //LocalVariableInstructionTest
